From 4ba2e55412fe435e27b68beb5e13476fa767a8aa Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 5 Oct 2012 22:10:50 -0500
Subject: [PATCH] Merged pki-silent into pki-server.

The pki-silent package has been merged into pki-server package.

Ticket #354
---
 base/silent/templates/pki_silent.template   | 11 +++----
 base/silent/templates/subca_silent.template | 11 +++----
 scripts/build_dogtag_pki                    |  3 +-
 specs/dogtag-pki.spec                       |  6 ++--
 specs/pki-core.spec                         | 49 +++++++----------------------
 specs/pki-ra.spec                           | 10 +++---
 specs/pki-tps.spec                          | 10 +++---
 7 files changed, 34 insertions(+), 66 deletions(-)

diff --git a/base/silent/templates/pki_silent.template b/base/silent/templates/pki_silent.template
index 93ff5849a199545a842dde23609f1d894e14e756..27e4ae77fa18a0cbff028f95233ccfcd774a3d08 100755
--- a/base/silent/templates/pki_silent.template
+++ b/base/silent/templates/pki_silent.template
@@ -19,15 +19,14 @@ if	[ "${pki_silent_script}" = "pki_silent.template" ] ; then
 	printf "Usage:  (1) Install AND configure a directory server instance.\n\n"
 	printf "        (2) Install, but do NOT configure ALL six\n"
 	printf "            'default' PKI subsystem instances.\n\n"
-	printf "        (3) Install the 'pki-silent' package.\n\n"
-	printf "        (4) Copy '$0' to a new script name\n"
+	printf "        (3) Copy '$0' to a new script name\n"
 	printf "            without the '.template' extension.\n"
 	printf "            (e .g. - 'configure_default_pki_instances')\n\n"
-	printf "        (5) Fill in all MANDATORY user-defined variables\n"
+	printf "        (4) Fill in all MANDATORY user-defined variables\n"
 	printf "            in the new script.\n\n"
-	printf "        (6) Change any OPTIONAL user-defined variables\n"
+	printf "        (5) Change any OPTIONAL user-defined variables\n"
 	printf "            in the new script as desired.\n\n"
-	printf "        (7) Become the 'root' user, and execute the new script to\n"
+	printf "        (6) Become the 'root' user, and execute the new script to\n"
 	printf "            configure ALL six 'default' PKI subsystem instances.\n\n"
 	exit 255
 fi
@@ -971,7 +970,7 @@ fi
 ## (3) Make certain that 'pkisilent' exists and is executable on this system.
 if [ ! -x "/usr/bin/pkisilent" ] ; then
 	printf "\n"
-	printf "ERROR:  Please install the 'pki-silent' package and re-run\n"
+	printf "ERROR:  Please install the 'pki-server' package and re-run\n"
 	printf "the '$0' script!\n\n"
 	exit 255
 fi
diff --git a/base/silent/templates/subca_silent.template b/base/silent/templates/subca_silent.template
index 1475996d17323a5b14bc18bc68890dc41fca4380..bbcc225529a4fc62a2440b0d71f5077c05863b87 100755
--- a/base/silent/templates/subca_silent.template
+++ b/base/silent/templates/subca_silent.template
@@ -22,15 +22,14 @@ if	[ "${subca_silent_script}" = "subca_silent.template" ] ; then
 	printf "        (3) Use 'pkicreate' to install a second CA subsystem\n"
 	printf "            instance (this will become a Subordinate CA).\n"
 	printf "            [Do NOT configure this CA subsystem instance!]\n\n"
-	printf "        (4) Install the 'pki-silent' package.\n\n"
-	printf "        (5) Copy '$0' to a new script name\n"
+	printf "        (4) Copy '$0' to a new script name\n"
 	printf "            without the '.template' extension.\n"
 	printf "            (e .g. - 'configure_subca_instance')\n\n"
-	printf "        (6) Fill in all MANDATORY user-defined variables\n"
+	printf "        (5) Fill in all MANDATORY user-defined variables\n"
 	printf "            in the new script.\n\n"
-	printf "        (7) Change any OPTIONAL user-defined variables\n"
+	printf "        (6) Change any OPTIONAL user-defined variables\n"
 	printf "            in the new script as desired.\n\n"
-	printf "        (8) Become the 'root' user, and execute the new script to\n"
+	printf "        (7) Become the 'root' user, and execute the new script to\n"
 	printf "            configure a Subordinate CA subsystem instance.\n\n"
 	exit 255
 fi
@@ -391,7 +390,7 @@ fi
 ## (3) Make certain that 'pkisilent' exists and is executable on this system.
 if [ ! -x "/usr/bin/pkisilent" ] ; then
 	printf "\n"
-	printf "ERROR:  Please install the 'pki-silent' package and re-run\n"
+	printf "ERROR:  Please install the 'pki-server' package and re-run\n"
 	printf "the '$0' script!\n\n"
 	exit 255
 fi
diff --git a/scripts/build_dogtag_pki b/scripts/build_dogtag_pki
index 5767f77b019aee9640a5014618995ac0d9962685..e360157121b94a6702b6975e225554f9df0feef6 100755
--- a/scripts/build_dogtag_pki
+++ b/scripts/build_dogtag_pki
@@ -137,7 +137,6 @@ PKI_CA=pki-ca${RPM_EXT}
 PKI_KRA=pki-kra${RPM_EXT}
 PKI_OCSP=pki-ocsp${RPM_EXT}
 PKI_TKS=pki-tks${RPM_EXT}
-PKI_SILENT=pki-silent${RPM_EXT}
 
 # Establish PKI ra package names
 PKI_RA=pki-ra${RPM_EXT}
@@ -171,7 +170,7 @@ cd ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}
 mkdir -p ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
 cp -p ${NOARCH}/*.rpm ${PKI_ARCH}/*.rpm ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
 cd ${PKI_CORE_PACKAGES_DIR}/${RPM_DIR}/${COMBINED}
-${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_SYMKEY} ${PKI_BASE} ${PKI_JAVADOC} ${PKI_TOOLS} ${PKI_SERVER} ${PKI_SELINUX} ${PKI_CA} ${PKI_KRA} ${PKI_OCSP} ${PKI_TKS} ${PKI_SILENT}
+${PKI_SUDO} ${YUM_EXE} ${YUM_EXE_OPTIONS} ${PKI_SYMKEY} ${PKI_BASE} ${PKI_JAVADOC} ${PKI_TOOLS} ${PKI_SERVER} ${PKI_SELINUX} ${PKI_CA} ${PKI_KRA} ${PKI_OCSP} ${PKI_TKS}
 
 # Compose and install 'pki-ra' packages
 cd ${PKI_PWD}
diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index 113024950386949d01673de4fc48b8cde4b7b5d3..f561e237208116f5dbaa6e1ad63cc64f7912f81e 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -8,7 +8,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
 Version:          10.0.0
-Release:          %{?relprefix}9%{?prerel}%{?dist}
+Release:          %{?relprefix}10%{?prerel}%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -99,7 +99,6 @@ Requires:         pki-ca >= %{pki_core_version}
 Requires:         pki-server >= %{pki_core_version}
 Requires:         pki-tools >= %{pki_core_version}
 Requires:         pki-selinux >= %{pki_core_version}
-Requires:         pki-silent >= %{pki_core_version}
 Requires:         pki-symkey >= %{pki_core_version}
 Requires:         pki-base >= %{pki_core_version}
 
@@ -194,6 +193,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Fri Oct 5 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.10.a2
+- Merged pki-silent into pki-server.
+
 * Mon Oct 1 2012 Ade Lee <alee@redhat.com> 10.0.0-0.9.a2
 - Update release to a2
 
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 0f4ff23a094635df0b67cd5f644f0e45c26805e7..a1eb03aea523c57f133ca61ba6694da697710f34 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -14,7 +14,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.0.0
-Release:          %{?relprefix}39%{?prerel}%{?dist}
+Release:          %{?relprefix}40%{?prerel}%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -137,7 +137,6 @@ Certificate System instances consisting of the following components:   \
                                                                        \
   * pki-tools                                                          \
   * pki-selinux                                                        \
-  * pki-silent (required for IPA deployments; optional otherwise)      \
                                                                        \
 Additionally, PKI Core contains the following fundamental packages     \
 required ONLY by ALL java-based Tomcat Certificate System instances:   \
@@ -286,10 +285,13 @@ BuildArch:        noarch
 
 Provides:         pki-deploy = %{version}-%{release}
 Provides:         pki-setup = %{version}-%{release}
+Provides:         pki-silent = %{version}-%{release}
 
 Obsoletes:        pki-deploy < %{version}-%{release}
 Obsoletes:        pki-setup < %{version}-%{release}
+Obsoletes:        pki-silent < %{version}-%{release}
 
+Requires:         java >= 1:1.6.0
 Requires:         perl(File::Slurp)
 Requires:         perl(XML::LibXML)
 Requires:         perl-Crypt-SSLeay
@@ -590,32 +592,6 @@ provided by the PKI Core used by the Certificate System.
 %{overview}
 
 
-%package -n       pki-silent
-Summary:          Certificate System - Silent Installer
-Group:            System Environment/Base
-
-BuildArch:        noarch
-
-Requires:         java >= 1:1.6.0
-Requires:         pki-server = %{version}-%{release}
-
-%description -n   pki-silent
-The PKI Silent Installer may be used to "automatically" configure
-the following PKI subsystems in a non-graphical (batch) fashion
-including:
-
-    the Certificate Authority (CA),
-    the Data Recovery Manager (DRM),
-    the Online Certificate Status Protocol (OCSP) Manager,
-    the Registration Authority (RA),
-    the Token Key Service (TKS), and/or
-    the Token Processing System (TPS).
-
-This package is a part of the PKI Core used by the Certificate System.
-
-%{overview}
-
-
 %package -n       pki-javadoc
 Summary:          Certificate System - PKI Framework Javadocs
 Group:            Documentation
@@ -1146,6 +1122,8 @@ fi
 %{_javadir}/pki/pki-cmsbundle.jar
 %{_javadir}/pki/pki-cmscore-%{version}.jar
 %{_javadir}/pki/pki-cmscore.jar
+%{_javadir}/pki/pki-silent-%{version}.jar
+%{_javadir}/pki/pki-silent.jar
 %{_javadir}/pki/pki-tomcat-%{version}.jar
 %{_javadir}/pki/pki-tomcat.jar
 %dir %{_localstatedir}/lock/pki/tomcat
@@ -1153,10 +1131,12 @@ fi
 %{_bindir}/pkicreate
 %{_bindir}/pkiremove
 %{_bindir}/pki-setup-proxy
+%{_bindir}/pkisilent
 %dir %{_datadir}/pki/scripts
 %{_datadir}/pki/scripts/pkicommon.pm
 %{_datadir}/pki/scripts/functions
 %{_datadir}/pki/scripts/pki_apache_initscript
+%{_datadir}/pki/silent/
 %dir %{_localstatedir}/lock/pki
 %dir %{_localstatedir}/run/pki
 %if 0%{?fedora} >= 16
@@ -1164,7 +1144,6 @@ fi
 %endif
 
 
-
 %if 0%{?fedora} >= 15
 # Details:
 #
@@ -1300,15 +1279,6 @@ fi
 %endif
 
 
-%files -n pki-silent
-%defattr(-,root,root,-)
-%doc base/silent/LICENSE
-%{_bindir}/pkisilent
-%{_javadir}/pki/pki-silent-%{version}.jar
-%{_javadir}/pki/pki-silent.jar
-%{_datadir}/pki/silent/
-
-
 %if %{?_without_javadoc:0}%{!?_without_javadoc:1}
 %files -n pki-javadoc
 %defattr(-,root,root,-)
@@ -1317,6 +1287,9 @@ fi
 
 
 %changelog
+* Fri Oct 5 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.40.a2
+- Merged pki-silent into pki-server.
+
 * Fri Oct 5 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.39.a2
 - Renamed "shared" folder to "server".
 
diff --git a/specs/pki-ra.spec b/specs/pki-ra.spec
index 98e07265219b17e8b92fb61c0c9e08ff30ed6c9a..14fb5d4352ce3e944cbdc028125f71620fe1b5f3 100644
--- a/specs/pki-ra.spec
+++ b/specs/pki-ra.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-ra
 Version:          10.0.0
-Release:          %{?relprefix}8%{?prerel}%{?dist}
+Release:          %{?relprefix}9%{?prerel}%{?dist}
 Summary:          Certificate System - Registration Authority
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -68,11 +68,6 @@ Core package:
   * pki-tools
   * pki-selinux
 
-and can also make use of the following optional components from the PKI Core
-package:
-
-  * pki-silent
-
 Additionally, Certificate System requires ONE AND ONLY ONE of the following
 "Mutually-Exclusive" PKI Theme packages:
 
@@ -248,6 +243,9 @@ fi
 
 
 %changelog
+* Fri Oct 5 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.9.a2
+- Merged pki-silent into pki-server.
+
 * Mon Oct 1 2012 Ade Lee <alee@redhat.com> 10.0.0-0.8.a2
 - Update release to a2
 
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index a7e1b7f8fbbd58550b3e3eb67f26cd1c2ec8f647..b49ed4ccbd2e5dcfab809b593762d4b9e0145c3e 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -7,7 +7,7 @@
 
 Name:             pki-tps
 Version:          10.0.0
-Release:          %{?relprefix}8%{?prerel}%{?dist}
+Release:          %{?relprefix}9%{?prerel}%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
 License:          LGPLv2
@@ -81,11 +81,6 @@ PKI Core package:                                                         \
   * pki-tools                                                             \
   * pki-selinux                                                           \
                                                                           \
-and can also make use of the following optional components from the       \
-PKI CORE package:                                                         \
-                                                                          \
-  * pki-silent                                                            \
-                                                                          \
 Additionally, Certificate System requires ONE AND ONLY ONE of the         \
 following "Mutually-Exclusive" PKI Theme packages:                        \
                                                                           \
@@ -283,6 +278,9 @@ fi
 
 
 %changelog
+* Fri Oct 5 2012 Endi S. Dewata <edewata@redhat.com> 10.0.0-0.9.a2
+- Merged pki-silent into pki-server.
+
 * Mon Oct 1 2012 Ade Lee <alee@redhat.com> 10.0.0-0.8.a2
 - Update release to a2
 
-- 
1.7.11.4