From 5aad23c17f68a8d2045f4e0564e4c0bee4713c08 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 9 Nov 2012 01:51:54 -0500
Subject: [PATCH] Reorganized common templates.

The common templates have moved from common-ui into base/common.
The deployment tools have been updated to use the new location.

Ticket #407
---
 .../admin/console/config/adminauthenticatepanel.vm |  0
 .../pki}/admin/console/config/adminpanel.vm        |  0
 .../admin/console/config/agentauthenticatepanel.vm |  0
 .../admin/console/config/backupkeycertpanel.vm     |  0
 .../pki}/admin/console/config/certchainpanel.vm    |  0
 .../admin/console/config/certprettyprintpanel.vm   |  0
 .../pki}/admin/console/config/certrequestpanel.vm  |  0
 .../pki}/admin/console/config/config_addhsm.vm     |  0
 .../admin/console/config/config_hsmloginpanel.vm   |  0
 .../admin/console/config/createsubsystempanel.vm   |  0
 .../pki}/admin/console/config/databasepanel.vm     |  0
 .../admin/console/config/displaycertchainpanel.vm  |  0
 .../webapps/pki}/admin/console/config/donepanel.vm |  0
 .../webapps/pki}/admin/console/config/footer.vm    |  0
 .../webapps/pki}/admin/console/config/header.vm    |  0
 .../pki}/admin/console/config/hierarchypanel.vm    |  0
 .../admin/console/config/importadmincertpanel.vm   |  0
 .../admin/console/config/importcachainpanel.vm     |  0
 .../webapps/pki}/admin/console/config/login.vm     |  0
 .../pki}/admin/console/config/modulepanel.vm       |  0
 .../webapps/pki}/admin/console/config/namepanel.vm |  0
 .../admin/console/config/restorekeycertpanel.vm    |  0
 .../pki}/admin/console/config/savepkcs12panel.vm   |  0
 .../console/config/securitydomainloginpanel.vm     |  0
 .../admin/console/config/securitydomainpanel.vm    |  0
 .../webapps/pki}/admin/console/config/sidemenu.vm  |  0
 .../webapps/pki}/admin/console/config/sizepanel.vm |  0
 .../webapps/pki}/admin/console/config/topmenu.vm   |  0
 .../pki}/admin/console/config/welcomepanel.vm      |  0
 .../webapps/pki}/admin/console/config/wizard.vm    |  0
 .../webapps/pki}/admin/console/config/xml.vm       |  0
 .../shared/webapps/pki}/admin/console/js/misc.js   |  0
 base/deploy/src/scriptlets/instance_layout.py      | 43 +++------------
 base/deploy/src/scriptlets/webapp_deployment.py    | 64 +++++-----------------
 base/setup/pkicreate                               | 40 +++-----------
 35 files changed, 29 insertions(+), 118 deletions(-)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/adminauthenticatepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/adminpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/agentauthenticatepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/backupkeycertpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/certchainpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/certprettyprintpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/certrequestpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/config_addhsm.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/config_hsmloginpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/createsubsystempanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/databasepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/displaycertchainpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/donepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/footer.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/header.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/hierarchypanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/importadmincertpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/importcachainpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/login.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/modulepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/namepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/restorekeycertpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/savepkcs12panel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/securitydomainloginpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/securitydomainpanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/sidemenu.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/sizepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/topmenu.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/welcomepanel.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/wizard.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/config/xml.vm (100%)
 rename {dogtag/common-ui/shared => base/common/shared/webapps/pki}/admin/console/js/misc.js (100%)

diff --git a/dogtag/common-ui/shared/admin/console/config/adminauthenticatepanel.vm b/base/common/shared/webapps/pki/admin/console/config/adminauthenticatepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/adminauthenticatepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/adminauthenticatepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/adminpanel.vm b/base/common/shared/webapps/pki/admin/console/config/adminpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/adminpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/adminpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/agentauthenticatepanel.vm b/base/common/shared/webapps/pki/admin/console/config/agentauthenticatepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/agentauthenticatepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/agentauthenticatepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/backupkeycertpanel.vm b/base/common/shared/webapps/pki/admin/console/config/backupkeycertpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/backupkeycertpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/backupkeycertpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/certchainpanel.vm b/base/common/shared/webapps/pki/admin/console/config/certchainpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/certchainpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/certchainpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/certprettyprintpanel.vm b/base/common/shared/webapps/pki/admin/console/config/certprettyprintpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/certprettyprintpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/certprettyprintpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/certrequestpanel.vm b/base/common/shared/webapps/pki/admin/console/config/certrequestpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/certrequestpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/certrequestpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/config_addhsm.vm b/base/common/shared/webapps/pki/admin/console/config/config_addhsm.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/config_addhsm.vm
rename to base/common/shared/webapps/pki/admin/console/config/config_addhsm.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/config_hsmloginpanel.vm b/base/common/shared/webapps/pki/admin/console/config/config_hsmloginpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/config_hsmloginpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/config_hsmloginpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/createsubsystempanel.vm b/base/common/shared/webapps/pki/admin/console/config/createsubsystempanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/createsubsystempanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/createsubsystempanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/databasepanel.vm b/base/common/shared/webapps/pki/admin/console/config/databasepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/databasepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/databasepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/displaycertchainpanel.vm b/base/common/shared/webapps/pki/admin/console/config/displaycertchainpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/displaycertchainpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/displaycertchainpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/donepanel.vm b/base/common/shared/webapps/pki/admin/console/config/donepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/donepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/donepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/footer.vm b/base/common/shared/webapps/pki/admin/console/config/footer.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/footer.vm
rename to base/common/shared/webapps/pki/admin/console/config/footer.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/header.vm b/base/common/shared/webapps/pki/admin/console/config/header.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/header.vm
rename to base/common/shared/webapps/pki/admin/console/config/header.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/hierarchypanel.vm b/base/common/shared/webapps/pki/admin/console/config/hierarchypanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/hierarchypanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/hierarchypanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/importadmincertpanel.vm b/base/common/shared/webapps/pki/admin/console/config/importadmincertpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/importadmincertpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/importadmincertpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/importcachainpanel.vm b/base/common/shared/webapps/pki/admin/console/config/importcachainpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/importcachainpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/importcachainpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/login.vm b/base/common/shared/webapps/pki/admin/console/config/login.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/login.vm
rename to base/common/shared/webapps/pki/admin/console/config/login.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/modulepanel.vm b/base/common/shared/webapps/pki/admin/console/config/modulepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/modulepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/modulepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/namepanel.vm b/base/common/shared/webapps/pki/admin/console/config/namepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/namepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/namepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/restorekeycertpanel.vm b/base/common/shared/webapps/pki/admin/console/config/restorekeycertpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/restorekeycertpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/restorekeycertpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/savepkcs12panel.vm b/base/common/shared/webapps/pki/admin/console/config/savepkcs12panel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/savepkcs12panel.vm
rename to base/common/shared/webapps/pki/admin/console/config/savepkcs12panel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/securitydomainloginpanel.vm b/base/common/shared/webapps/pki/admin/console/config/securitydomainloginpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/securitydomainloginpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/securitydomainloginpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/securitydomainpanel.vm b/base/common/shared/webapps/pki/admin/console/config/securitydomainpanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/securitydomainpanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/securitydomainpanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/sidemenu.vm b/base/common/shared/webapps/pki/admin/console/config/sidemenu.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/sidemenu.vm
rename to base/common/shared/webapps/pki/admin/console/config/sidemenu.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/sizepanel.vm b/base/common/shared/webapps/pki/admin/console/config/sizepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/sizepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/sizepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/topmenu.vm b/base/common/shared/webapps/pki/admin/console/config/topmenu.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/topmenu.vm
rename to base/common/shared/webapps/pki/admin/console/config/topmenu.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/welcomepanel.vm b/base/common/shared/webapps/pki/admin/console/config/welcomepanel.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/welcomepanel.vm
rename to base/common/shared/webapps/pki/admin/console/config/welcomepanel.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/wizard.vm b/base/common/shared/webapps/pki/admin/console/config/wizard.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/wizard.vm
rename to base/common/shared/webapps/pki/admin/console/config/wizard.vm
diff --git a/dogtag/common-ui/shared/admin/console/config/xml.vm b/base/common/shared/webapps/pki/admin/console/config/xml.vm
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/config/xml.vm
rename to base/common/shared/webapps/pki/admin/console/config/xml.vm
diff --git a/dogtag/common-ui/shared/admin/console/js/misc.js b/base/common/shared/webapps/pki/admin/console/js/misc.js
similarity index 100%
rename from dogtag/common-ui/shared/admin/console/js/misc.js
rename to base/common/shared/webapps/pki/admin/console/js/misc.js
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/deploy/src/scriptlets/instance_layout.py
index 41327252ae3e29b16960a98a7841b007579e6551..85f312fed9bd3f6b4f1cc3b418c3a5e624f169ab 100644
--- a/base/deploy/src/scriptlets/instance_layout.py
+++ b/base/deploy/src/scriptlets/instance_layout.py
@@ -72,28 +72,13 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             util.directory.create(master['pki_tomcat_webapps_path'])
             util.directory.create(master['pki_tomcat_webapps_common_path'])
 
-            # Copy /usr/share/pki/common-ui/css
-            # to <instance>/webapp/pki/css
+            # Copy /usr/share/pki/common-ui
+            # to <instance>/webapp/pki
             util.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    "common-ui",
-                    "css"),
-                os.path.join(
-                    master['pki_tomcat_webapps_common_path'],
-                    "css"),
-                overwrite_flag=True)
-
-            # Copy /usr/share/pki/common-ui/images
-            # to <instance>/webapp/pki/images
-            util.directory.copy(
-                os.path.join(
-                    config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    "common-ui",
-                    "images"),
-                os.path.join(
-                    master['pki_tomcat_webapps_common_path'],
-                    "images"),
+                    "common-ui"),
+                master['pki_tomcat_webapps_common_path'],
                 overwrite_flag=True)
 
             util.directory.create(master['pki_tomcat_webapps_root_path'])
@@ -200,28 +185,14 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             util.directory.modify(master['pki_instance_lib_log4j_properties'])
             util.directory.modify(master['pki_tomcat_webapps_path'])
 
-            # Copy /usr/share/pki/common-ui/css
-            # to <instance>/webapp/pki/css
+            # Copy /usr/share/pki/common-ui
+            # to <instance>/webapp/pki
             util.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
                     "common-ui",
                     "css"),
-                os.path.join(
-                    master['pki_tomcat_webapps_common_path'],
-                    "css"),
-                overwrite_flag=True)
-
-            # Copy /usr/share/pki/common-ui/images
-            # to <instance>/webapp/pki/images
-            util.directory.copy(
-                os.path.join(
-                    config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    "common-ui",
-                    "images"),
-                os.path.join(
-                    master['pki_tomcat_webapps_common_path'],
-                    "images"),
+                master['pki_tomcat_webapps_common_path'],
                 overwrite_flag=True)
 
             util.directory.copy(
diff --git a/base/deploy/src/scriptlets/webapp_deployment.py b/base/deploy/src/scriptlets/webapp_deployment.py
index 28aa31dc54e98d32d54bedd6fa17404aab2e1f8a..68fff20bd3c99973b1052e1b7834093dcb1b5e96 100644
--- a/base/deploy/src/scriptlets/webapp_deployment.py
+++ b/base/deploy/src/scriptlets/webapp_deployment.py
@@ -48,36 +48,18 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             # deploy webapp
             util.directory.create(master['pki_tomcat_webapps_subsystem_path'])
 
-            # Copy /usr/share/pki/common-ui/admin/console/config
-            # to <instance>/webapp/<subsystem>/admin/console/config
+            # Copy /usr/share/pki/server/webapps/pki/admin
+            # to <instance>/webapp/<subsystem>/admin
             util.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    "common-ui",
-                    "admin",
-                    "console",
-                    "config"),
+                    "server",
+                    "webapps",
+                    "pki",
+                    "admin"),
                 os.path.join(
                     master['pki_tomcat_webapps_subsystem_path'],
-                    "admin",
-                    "console",
-                    "config"),
-                overwrite_flag=True)
-
-            # Copy /usr/share/pki/common-ui/admin/console/js
-            # to <instance>/webapp/<subsystem>/admin/console/js
-            util.directory.copy(
-                os.path.join(
-                    config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    "common-ui",
-                    "admin",
-                    "console",
-                    "js"),
-                os.path.join(
-                    master['pki_tomcat_webapps_subsystem_path'],
-                    "admin",
-                    "console",
-                    "js"),
+                    "admin"),
                 overwrite_flag=True)
 
             util.directory.copy(
@@ -137,36 +119,18 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             # redeploy webapp
             util.directory.modify(master['pki_tomcat_webapps_subsystem_path'])
 
-            # Copy /usr/share/pki/common-ui/admin/console/config
-            # to <instance>/webapp/<subsystem>/admin/console/config
+            # Copy /usr/share/pki/server/webapps/pki/admin
+            # to <instance>/webapp/<subsystem>/admin
             util.directory.copy(
                 os.path.join(
                     config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    "common-ui",
-                    "admin",
-                    "console",
-                    "config"),
+                    "server",
+                    "webapps",
+                    "pki",
+                    "admin"),
                 os.path.join(
                     master['pki_tomcat_webapps_subsystem_path'],
-                    "admin",
-                    "console",
-                    "config"),
-                overwrite_flag=True)
-
-            # Copy /usr/share/pki/common-ui/admin/console/js
-            # to <instance>/webapp/<subsystem>/admin/console/js
-            util.directory.copy(
-                os.path.join(
-                    config.PKI_DEPLOYMENT_SOURCE_ROOT,
-                    "common-ui",
-                    "admin",
-                    "console",
-                    "js"),
-                os.path.join(
-                    master['pki_tomcat_webapps_subsystem_path'],
-                    "admin",
-                    "console",
-                    "js"),
+                    "admin"),
                 overwrite_flag=True)
 
             util.directory.copy(
diff --git a/base/setup/pkicreate b/base/setup/pkicreate
index 6b503fe7eb73ef67946ba919053cad9853813182..6f63e96e85bc461960031aa59ab75ffd46446dc1 100755
--- a/base/setup/pkicreate
+++ b/base/setup/pkicreate
@@ -2065,27 +2065,11 @@ sub process_pki_directories
                                     $default_dir_permissions, $default_file_permissions,
                                     $pki_user, $pki_group);
 
-        # Copy /usr/share/pki/common-ui/css
-        # to <instance>/docroot/pki/css
+        # Copy /usr/share/pki/common-ui
+        # to <instance>/docroot/pki
         return 0 if !copy_directory(
-            "$common_ui_subsystem_path/css",
-            "$docroot_instance_path/pki/css",
-            $default_dir_permissions, $default_file_permissions,
-            $pki_user, $pki_group);
-
-        # Copy /usr/share/pki/common-ui/esc
-        # to <instance>/docroot/pki/esc
-        return 0 if !copy_directory(
-            "$common_ui_subsystem_path/esc",
-            "$docroot_instance_path/pki/esc",
-            $default_dir_permissions, $default_file_permissions,
-            $pki_user, $pki_group);
-
-        # Copy /usr/share/pki/common-ui/images
-        # to <instance>/docroot/pki/images
-        return 0 if !copy_directory(
-            "$common_ui_subsystem_path/images",
-            "$docroot_instance_path/pki/images",
+            $common_ui_subsystem_path,
+            "$docroot_instance_path/pki",
             $default_dir_permissions, $default_file_permissions,
             $pki_user, $pki_group);
 
@@ -2116,19 +2100,11 @@ sub process_pki_directories
                                     $default_dir_permissions, $default_file_permissions,
                                     $pki_user, $pki_group);
 
-        # Copy /usr/share/pki/common-ui/admin/console/config
-        # to <instance>/webapp/<subsystem>/admin/console/config
+        # Copy /usr/share/pki/server/webapps/pki/admin
+        # to <instance>/webapp/<subsystem>/admin
         return 0 if !copy_directory(
-            "$common_ui_subsystem_path/admin/console/config",
-            "$webapps_subsystem_instance_path/admin/console/config",
-            $default_dir_permissions, $default_file_permissions,
-            $pki_user, $pki_group);
-
-        # Copy /usr/share/pki/common-ui/admin/console/js
-        # to <instance>/webapp/<subsystem>/admin/console/js
-        return 0 if !copy_directory(
-            "$common_ui_subsystem_path/admin/console/js",
-            "$webapps_subsystem_instance_path/admin/console/js",
+            "$pki_subsystem_common_area/server/webapps/pki/admin",
+            "$webapps_subsystem_instance_path/admin",
             $default_dir_permissions, $default_file_permissions,
             $pki_user, $pki_group);
 
-- 
1.7.12.1